/*
 *
 * Copyright(C) OASIS(R) 2005,2009. All Rights Reserved.
 * OASIS trademark, IPR and other policies apply.    
 *   
 */

/**
 * Test initiation implementation with a single reference of multiplicity 1..1
 * @author Bryan Aupperle
 *
 */

#include "TestInvocation.h"
#include "..\SCA.h"

/* @Property */
char testName[50];

/* @Reference(name="reference1", interfaceHeader="Service1.h", multiple="true") */

struct TestExceptionMsg testFault;
	
char *invokeTest(const char *input) {
	SCAREF serviceTokens[10], pServiceTokens = serviceTokens;
	int num_targets, compCode, reason, size = 50, i;
	char *pTestName = testName, response[255] = "", response1[25], *result;

	SCAPropertyCString(L"testName", &pTestName, &size, &compCode, &reason);

	result = (char *)malloc(255);  /* infrastructure must free this */
	
	SCAGetReferences(L"reference1", pServiceTokens, &num_targets, &compCode, &reason);
	for (i = 0; i < num_targets; i++) {
		size = 25;
		SCAInvoke(serviceTokens[i], L"operation1", strlen(input), (void *)input,
		          &size, (void *)response1, &compCode, &reason);
		strcat(response, response1);
	}
	strcpy(result, testName);
	strcat(result, " ");
	strcat(result, input);
	strcat(result, " ");
	strcat(result, response);

	return result;
};
