/*
 *
 * Copyright(C) OASIS(R) 2005,2009. All Rights Reserved.
 * OASIS trademark, IPR and other policies apply.    
 *   
 */

/**
 * Enhanced C component implementation for business interface Service1,
 * where the implementation also has a single reference using the Service1
 * interface with mutiplicity 0..n all of which and which get called when 
 * operation1 is invoked
 * @author Bryan Aupperle
 *
 */


#include "Service1.h"
#include "..\SCA.h"

/* @Property */
char serviceName[50];

// Required = false + multiple = true -> multiplicity 0..n
/* @Reference(name="reference1", interfaceHeader="Service1.h", required="false", multiple="true") */

char result[255];

char *operation1(const char *input) {
	SCAREF serviceTokens[10], pServiceTokens = serviceTokens;
	int num_targets, compCode, reason, size = 50, i;
	char *pServiceName = serviceName, response1[25], *result;

	SCAPropertyCString(L"serviceName", &pServiceName, &size, &compCode, &reason);
	
	result = (char *)malloc(255);  /* infrastructure must free this */
	strcpy(result, serviceName);
	strcat(result, " operation1 invoked ");

	SCAGetReferences(L"reference1", pServiceTokens, &num_targets, &compCode, &reason);
	for (i = 0; i < num_targets; i++) {
		size = 25;
		SCAInvoke(serviceTokens[i], L"operation1", strlen(input), (void *)input,
	              &size, (void *)response1, &compCode, &reason);
		strcat(result, response1);
	}
	
	return result;
};
